asyncapi: 3.0.0
info:
    title: Bicycle Counters
    version: 1.0.0
    description: Bicycle Counters
channels:
    bicyclecounters.refreshCameaDataLastXHoursInDB:
        address: dataplatform.bicyclecounters.refreshCameaDataLastXHoursInDB
        description: updates locations, direction database tables and sends message to queue updateCamea
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            empty:
                $ref: "#/components/messages/emptyMessage"
    bicyclecounters.refreshCameaDataPreviousDayInDB:
        address: dataplatform.bicyclecounters.refreshCameaDataPreviousDayInDB
        description: updates locations, direction database tables and sends message to queue updateCamea
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            empty:
                $ref: "#/components/messages/emptyMessage"
    bicyclecounters.refreshCameaDataSpecificDayInDB:
        address: dataplatform.bicyclecounters.refreshCameaDataSpecificDayInDB
        description: updates locations, direction database tables and sends message to queue updateCamea
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            date:
                $ref: "#/components/messages/bicyclecounters.date"
    bicyclecounters.updateCamea:
        address: dataplatform.bicyclecounters.updateCamea
        description: based on the parameters from the message updates measurement data in the database
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            vendorAndDuration:
                $ref: "#/components/messages/bicyclecounters.vendorAndDuration"
    bicyclecounters.refreshEcoCounterDataInDB:
        address: dataplatform.bicyclecounters.refreshEcoCounterDataInDB
        description: updates locations, direction database tables and sends multiple messages to queue updateEcoCounter (1 for each direction)
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            empty:
                $ref: "#/components/messages/emptyMessage"
    bicyclecounters.updateEcoCounter:
        address: dataplatform.bicyclecounters.updateEcoCounter
        description: based on the parameters from the message updates measurement data in the database
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            updateEcoCounterMessage:
                $ref: "#/components/messages/bicyclecounters.updateEcoCounterMessage"
operations:
    bicyclecounters.refreshCameaDataLastXHoursInDB:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.refreshCameaDataLastXHoursInDB"
    bicyclecounters.refreshCameaDataPreviousDayInDB:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.refreshCameaDataPreviousDayInDB"
    bicyclecounters.refreshCameaDataSpecificDayInDB:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.refreshCameaDataSpecificDayInDB"
    bicyclecounters.updateCamea:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.updateCamea"
    bicyclecounters.refreshEcoCounterDataInDB:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.refreshEcoCounterDataInDB"
    bicyclecounters.updateEcoCounter:
        action: "send"
        channel:
            $ref: "#/channels/bicyclecounters.updateEcoCounter"
components:
    messages:
        emptyMessage:
            title: Empty message
        bicyclecounters.vendorAndDuration:
            payload:
                type: object
                $ref: "#/components/schemas/bicyclecounters.IVendorAndDuration"
                additionalProperties: false
        bicyclecounters.date:
            payload:
                type: object
                properties:
                    date:
                        type: string
                        format: date
                additionalProperties: false
        bicyclecounters.updateEcoCounterMessage:
            payload:
              type: object
              $ref: "#/components/schemas/bicyclecounters.IUpdateEcoCounterMessage"
              additionalProperties: false            
    schemas:
        bicyclecounters.IVendorAndDuration:
            type: object
            properties:
                id:
                    type: string
                    description: vendor id
                duration:
                    type: number
                    description: supports three modes 0 - last3Hours, 1 - previousDay, 2 - specificDay
                    enum: 
                        - 0
                        - 1
                        - 2
                date:
                    type: string
                    nullable: true
                    format: date
                    description: relevant only if duration is 2
            additionalProperties: false
        bicyclecounters.IUpdateEcoCounterMessage:
            type: object
            properties:
                id:
                    type: string
                    description: vendor id
                category:
                    type: string
                    description: category of the counter, only 'bicycle' is used
                directions_id:
                    type: string
                    description: direction id
                locations_id:
                    type: string
                    description: location id
            additionalProperties: false
